#include <bits/stdc++.h>

using namespace std;

int gao(int n,int m,int x){
	int st=-1,en=-1;
	if (x-1<=m) st=1;
		else st=x-m;
	if (x-n>=1) en=n;
		else en=x-1;
	if (st<=n && st>=1)
		if (en>=1 && en<=n)
			if (en>=st) return en-st+1;
	return 0;
}

int main(){
	int T,n,m,q,x;
	scanf("%d",&T);
	for (int ti=1;ti<=T;ti++){
		scanf("%d%d",&n,&m);
		printf("Case #%d:\n",ti);
		scanf("%d",&q);
		for (int i=1;i<=q;i++){
			scanf("%d",&x);
			printf("%d\n",gao(n,m,x));
		}
	}
	return 0;
}

